DECLARE FUNCTION SBInitDriver% (CardType%, CardPORT%, CardIRQ%, CardDMA%)
DECLARE FUNCTION SBByeDriver%
DECLARE FUNCTION SBLoadSong% (SongName AS STRING)
DECLARE FUNCTION SBRemoveSong%
DECLARE FUNCTION SBPlaySong% (SongRepeat%, StartPattern%)
DECLARE FUNCTION SBStopSong%

DECLARE FUNCTION SBLoadSND% (Slot%, SNDName AS STRING)
DECLARE FUNCTION SBUnLoadSND% (Slot%)
DECLARE FUNCTION SBPlaySND% (Slot%, Channel%, LeftVol%, RightVol%, Frequency%)

DECLARE FUNCTION SBEditSND% (Slot%, LoopAt%, LoopTo%)
DECLARE FUNCTION SBGetMixerVol%
DECLARE FUNCTION SBSetMixerVol% (RightVolume%, LeftVolume%)
DECLARE FUNCTION SBGetCurPattern%
DECLARE FUNCTION SBGetCurModule%
DECLARE FUNCTION SBGetCurModuleRow%

DECLARE FUNCTION SBGetOutSEG%          'Returns DMA Segment
DECLARE FUNCTION SBGetOutOffset%       'Returns Current DMA Offset (Changes as time passes)
DECLARE FUNCTION SBGetOutLength%       'Returns Length of DMA Segment to read (=1042 if Stereo, =521 if Mono)

' This function returns the hit value for the specified Channel Number
' It will return a value between 0 and 32 dependant on the time since a note
' was last played and the volume of the channel.
'  Note: It may look a bit strange for volume fades (ie. I tried to make it
'  increase or decrease when the volume command was activating).
'  It looks weird because a volume 'fade out' makes the bars jump to the
'  current volume settings, so they seem to jump up for no reason!
'  (Play EXAMPLE.SB to see what I mean).

DECLARE FUNCTION SBGetChannelHit% (ChannelNumber%)

' And here is the new 'Get Information' sub-routine, which returns
' information about the song currently loaded.

DECLARE SUB SBReturnInfo (TotalPatterns%, TotalModules%, TotalSamples%)




' This is an internal sub-routine to SONTEST.BAS!
DECLARE SUB DrawSample ()
DECLARE SUB DrawPlayBar ()

' Start up QB with - "qb /lsondrv.qlb" to include sonic library
' Note: It is very important that you DE-INITIALIZE the driver when exiting
'       the program with FUNCTION SBByeDriver.  If you do not, then the memory
'       used by the driver will not be freed.

COMMON SHARED ErrorCode AS INTEGER
PRINT SETMEM(-200000)                    ' Free about 200K from the far heap

SCREEN 12: CLS
RANDOMIZE TIMER

INPUT "Enter Name of Song to Play"; SongName$
SongName$ = SongName$ + CHR$(0)          ' Filename must be zero-terminated
CLS

Blst$ = ENVIRON$("BLASTER")              ' Get Sound Blaster settings
SoundBPort% = VAL("&H" + MID$(Blst$, INSTR(Blst$, "A") + 1, 3))
SoundBIRQ% = VAL("&H" + MID$(Blst$, INSTR(Blst$, "I") + 1, 1))
SoundBDMA% = VAL("&H" + MID$(Blst$, INSTR(Blst$, "D") + 1, 1))

ErrorCode = SBInitDriver(0, SoundBPort%, SoundBIRQ%, SoundBDMA%)
IF ErrorCode = 0 THEN
 ErrorCode = SBLoadSong(SongName$)       ' Load the song
 IF ErrorCode = 0 THEN
  ErrorCode = SBPlaySong(1, 0)           ' Play the sound - (Repeat, Start at
  IF ErrorCode = 0 THEN                  ' pattern 0)
  
   CALL SBReturnInfo(TotPats%, TotMods%, TotSamps%)
  
   DO
    LOCATE 1, 1
    PRINT "Pattern:"; SBGetCurPattern; "/"; TotPats% - 1; "  Module:"; SBGetCurModule; "/"; TotMods% - 1; "  ModuleRow:"; SBGetCurModuleRow; "  Instruments in Song:"; TotSamps%

    'CALL DrawSample                     ' Un-Highlight this for osiliscope
    CALL DrawPlayBar                     ' Highlight this to turn off hit bar

    key$ = INKEY$
   LOOP UNTIL NOT key$ = ""
   ErrorCode = SBStopSong                ' Stop the song
   ErrorCode = SBRemoveSong              ' Remove song from memory
  ELSE                                   ' (Don't really need to do this!)
   PRINT "Error:"; ErrorCode
   key$ = INPUT$(1)
  END IF
 ELSE
  PRINT "Error:"; ErrorCode
  key$ = INPUT$(1)
 END IF
 ErrorCode = SBByeDriver                 ' Close down driver
ELSE
 PRINT "Error:"; ErrorCode
 key$ = INPUT$(1)
END IF

SUB DrawPlayBar

 ' This draws the hit bars

 FOR f% = 0 TO 7
  LOCATE 3 + f%, 1
  PRINT STRING$(SBGetChannelHit(f%), "*"); TAB(60);
 NEXT

END SUB

SUB DrawSample
   
' This VERY Crudely draws the sample (I am sure you can make it faster).
' The stereo sampled data is stored as LeftSample:BYTE, RightSample:BYTE
' The mono sampled data is stored as Sample:BYTE

DEF SEG = SBGetOutSEG                      ' Set seg to DMA Segment
Offs% = SBGetOutOffset                     ' Get offset of currently playing DMA
ScreenX% = 0
IF SBGetOutLength = 1042 THEN              ' If playing in stereo.
 FOR Offset% = Offs% TO Offs% + SBGetOutLength - 1 STEP 2
  ScreenX% = ScreenX% + 1
  LeftSample% = PEEK(Offset%)
  RightSample% = PEEK(Offset% + 1)
  LINE (ScreenX%, 15)-(ScreenX%, 480), 0
  PSET (ScreenX%, LeftSample% + 15), 15
  PSET (ScreenX%, RightSample% + 280), 15
 NEXT
ELSE                                       ' If playing in mono.
 FOR Offset% = Offs% TO Offs% + SBGetOutLength - 1
  ScreenX% = ScreenX% + 1
  sample% = PEEK(Offset%)
  LINE (ScreenX%, 15)-(ScreenX%, 230), 0
  PSET (ScreenX%, sample% + 15), 15
 NEXT
END IF

END SUB

